program jcAbs
  ! Calculates absolute values for complex and real values
  ! Real or complex in, real out

  use sep

  implicit none

  ! declare variables
  integer                           :: n1,n2,n3,n4,esize,ii
  real,allocatable,dimension (:)    :: datar
  complex,allocatable,dimension (:) :: datac

  ! open I/O
  call sep_init()

  call from_history('n1',n1,1)
  call from_history('n2',n2,1)
  call from_history('n3',n3,1)
  call from_history('n4',n4,1)

  call from_history('esize',esize)
  if (esize.eq.4) write(0,*) "Real Input"
  if (esize.eq.8) write(0,*) "Complex Input"
  call to_history('esize',4)

  call sep_close()

  ! allocate
  if (esize.eq.4) allocate(datar(n1))
  if (esize.eq.8) allocate(datac(n1))

  ! compute
  do ii=1,n2*n3*n4
    if (esize.eq.4) then
      call sreed('in',datar,4*n1)
      call srite('out',abs(datar),4*n1)
    end if
    if (esize.eq.8) then
      call sreed('in',datac,8*n1)
      call srite('out',cabs(datac),4*n1)
    end if
  end do

end program jcAbs
